Attribute VB_Name = "WlanONModule"
'' quick and dirty hack to enable wlan on bootup
'' use at your own risk
'' (c) 2006 Michael Schierl
'' Licensed under GNU General Public License Version 2
Option Explicit

Private Const TH32CS_SNAPPROCESS = 2
Private Type PROCESSENTRY32
     dwSize As Long
     cntUsage As Long
     th32ProcessID As Long
     th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * 260
End Type

Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long
Private Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, ByRef lppe As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, ByRef lppe As PROCESSENTRY32) As Long

Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long

Private scanresult As Long

Function EnumWindowsProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
    Dim pid As Long, name As String
    GetWindowThreadProcessId hwnd, pid
    name = GetProcessFileName(pid)
    If UCase(name) = "PM.EXE" Then
        scanresult = hwnd
    End If
    EnumWindowsProc = CInt(True)
End Function

Function GetProcessFileName(pid As Long) As String
    Dim hi As Long, th32 As PROCESSENTRY32, result As String, rr As Long
    result = ""
    hi = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
    th32.dwSize = Len(th32)
    Process32First hi, th32
    Do
        If th32.th32ProcessID = pid Then result = Left$(th32.szExeFile, InStr(th32.szExeFile, Chr$(0)) - 1)
        rr = Process32Next(hi, th32)
        If rr <> 1 Then Exit Do
    Loop
    CloseHandle hi
    GetProcessFileName = result
End Function


Function FindPowerManager()
    EnumWindows AddressOf EnumWindowsProc, 0
    FindPowerManager = scanresult
End Function


Sub Main()
    '' do not do anything when Caps Lock is on
    If (GetKeyState(vbKeyCapital) And 1) = 1 Then Exit Sub
    Dim hwnd As Long, t As Single
    Do
        hwnd = FindPowerManager
        If hwnd <> 0 Then Exit Do
        t = Timer
        Do
            DoEvents
        Loop Until t + 1 < Timer
    Loop
    Debug.Print hwnd
    SendMessage hwnd, &H83EA&, 1, 0  ' for off replace 1 by 0
    '' for throttling replace &H83EA& by &H83E9&
End Sub
